-- Do not edit.  Generated on Wed Dec 09 15:58:48 2020 by jgill
-- With Cheby 1.4.dev0 and these options:
--  -i wr2rf_init_rf_regs.cheby --gen-hdl wr2rf_init_rf_regs.vhd


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity wr2rf_init_rf_regs is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- Control register for both channels
    rf1_common_mixer_en_o : out   std_logic;
    rf1_common_mux_sel_o : out   std_logic_vector(1 downto 0);

    -- REG csr
    rf1_ch_0_csr_delay_oen_o : out   std_logic;
    rf1_ch_0_csr_mux_sel_o : out   std_logic;

    -- REG delay
    rf1_ch_0_delay_o     : out   std_logic_vector(15 downto 0);
    rf1_ch_0_delay_wr_o  : out   std_logic;

    -- REG csr
    rf1_ch_1_csr_delay_oen_o : out   std_logic;
    rf1_ch_1_csr_mux_sel_o : out   std_logic;

    -- REG delay
    rf1_ch_1_delay_o     : out   std_logic_vector(15 downto 0);
    rf1_ch_1_delay_wr_o  : out   std_logic;

    -- Control register for both channels
    rf2_common_mixer_en_o : out   std_logic;
    rf2_common_mux_sel_o : out   std_logic_vector(1 downto 0);

    -- REG csr
    rf2_ch_0_csr_delay_oen_o : out   std_logic;
    rf2_ch_0_csr_mux_sel_o : out   std_logic;

    -- REG delay
    rf2_ch_0_delay_o     : out   std_logic_vector(15 downto 0);
    rf2_ch_0_delay_wr_o  : out   std_logic;

    -- REG csr
    rf2_ch_1_csr_delay_oen_o : out   std_logic;
    rf2_ch_1_csr_mux_sel_o : out   std_logic;

    -- REG delay
    rf2_ch_1_delay_o     : out   std_logic_vector(15 downto 0);
    rf2_ch_1_delay_wr_o  : out   std_logic
  );
end wr2rf_init_rf_regs;

architecture syn of wr2rf_init_rf_regs is
  signal adr_int                        : std_logic_vector(4 downto 1);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal rf1_common_mixer_en_reg        : std_logic;
  signal rf1_common_mux_sel_reg         : std_logic_vector(1 downto 0);
  signal rf1_common_wreq                : std_logic;
  signal rf1_common_wack                : std_logic;
  signal rf1_ch_0_csr_delay_oen_reg     : std_logic;
  signal rf1_ch_0_csr_mux_sel_reg       : std_logic;
  signal rf1_ch_0_csr_wreq              : std_logic;
  signal rf1_ch_0_csr_wack              : std_logic;
  signal rf1_ch_0_delay_reg             : std_logic_vector(15 downto 0);
  signal rf1_ch_0_delay_wreq            : std_logic;
  signal rf1_ch_0_delay_wack            : std_logic;
  signal rf1_ch_1_csr_delay_oen_reg     : std_logic;
  signal rf1_ch_1_csr_mux_sel_reg       : std_logic;
  signal rf1_ch_1_csr_wreq              : std_logic;
  signal rf1_ch_1_csr_wack              : std_logic;
  signal rf1_ch_1_delay_reg             : std_logic_vector(15 downto 0);
  signal rf1_ch_1_delay_wreq            : std_logic;
  signal rf1_ch_1_delay_wack            : std_logic;
  signal rf2_common_mixer_en_reg        : std_logic;
  signal rf2_common_mux_sel_reg         : std_logic_vector(1 downto 0);
  signal rf2_common_wreq                : std_logic;
  signal rf2_common_wack                : std_logic;
  signal rf2_ch_0_csr_delay_oen_reg     : std_logic;
  signal rf2_ch_0_csr_mux_sel_reg       : std_logic;
  signal rf2_ch_0_csr_wreq              : std_logic;
  signal rf2_ch_0_csr_wack              : std_logic;
  signal rf2_ch_0_delay_reg             : std_logic_vector(15 downto 0);
  signal rf2_ch_0_delay_wreq            : std_logic;
  signal rf2_ch_0_delay_wack            : std_logic;
  signal rf2_ch_1_csr_delay_oen_reg     : std_logic;
  signal rf2_ch_1_csr_mux_sel_reg       : std_logic;
  signal rf2_ch_1_csr_wreq              : std_logic;
  signal rf2_ch_1_csr_wack              : std_logic;
  signal rf2_ch_1_delay_reg             : std_logic_vector(15 downto 0);
  signal rf2_ch_1_delay_wreq            : std_logic;
  signal rf2_ch_1_delay_wack            : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(15 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(4 downto 1);
  signal wr_dat_d0                      : std_logic_vector(15 downto 0);
  signal wr_sel_d0                      : std_logic_vector(1 downto 0);
begin

  -- WB decode signals
  adr_int <= wb_i.adr(4 downto 1);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wr_req_d0 <= '0';
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat(15 downto 0) <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat(15 downto 0);
        wr_sel_d0 <= wb_i.sel(1 downto 0);
      end if;
    end if;
  end process;

  -- Register rf1_common
  rf1_common_mixer_en_o <= rf1_common_mixer_en_reg;
  rf1_common_mux_sel_o <= rf1_common_mux_sel_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf1_common_mixer_en_reg <= '0';
        rf1_common_mux_sel_reg <= "00";
        rf1_common_wack <= '0';
      else
        if rf1_common_wreq = '1' then
          rf1_common_mixer_en_reg <= wr_dat_d0(0);
          rf1_common_mux_sel_reg <= wr_dat_d0(2 downto 1);
        end if;
        rf1_common_wack <= rf1_common_wreq;
      end if;
    end if;
  end process;

  -- Register rf1_ch_0_csr
  rf1_ch_0_csr_delay_oen_o <= rf1_ch_0_csr_delay_oen_reg;
  rf1_ch_0_csr_mux_sel_o <= rf1_ch_0_csr_mux_sel_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf1_ch_0_csr_delay_oen_reg <= '0';
        rf1_ch_0_csr_mux_sel_reg <= '0';
        rf1_ch_0_csr_wack <= '0';
      else
        if rf1_ch_0_csr_wreq = '1' then
          rf1_ch_0_csr_delay_oen_reg <= wr_dat_d0(0);
          rf1_ch_0_csr_mux_sel_reg <= wr_dat_d0(1);
        end if;
        rf1_ch_0_csr_wack <= rf1_ch_0_csr_wreq;
      end if;
    end if;
  end process;

  -- Register rf1_ch_0_delay
  rf1_ch_0_delay_o <= rf1_ch_0_delay_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf1_ch_0_delay_reg <= "0000000000000000";
        rf1_ch_0_delay_wack <= '0';
      else
        if rf1_ch_0_delay_wreq = '1' then
          rf1_ch_0_delay_reg <= wr_dat_d0;
        end if;
        rf1_ch_0_delay_wack <= rf1_ch_0_delay_wreq;
      end if;
    end if;
  end process;
  rf1_ch_0_delay_wr_o <= rf1_ch_0_delay_wack;

  -- Register rf1_ch_1_csr
  rf1_ch_1_csr_delay_oen_o <= rf1_ch_1_csr_delay_oen_reg;
  rf1_ch_1_csr_mux_sel_o <= rf1_ch_1_csr_mux_sel_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf1_ch_1_csr_delay_oen_reg <= '0';
        rf1_ch_1_csr_mux_sel_reg <= '0';
        rf1_ch_1_csr_wack <= '0';
      else
        if rf1_ch_1_csr_wreq = '1' then
          rf1_ch_1_csr_delay_oen_reg <= wr_dat_d0(0);
          rf1_ch_1_csr_mux_sel_reg <= wr_dat_d0(1);
        end if;
        rf1_ch_1_csr_wack <= rf1_ch_1_csr_wreq;
      end if;
    end if;
  end process;

  -- Register rf1_ch_1_delay
  rf1_ch_1_delay_o <= rf1_ch_1_delay_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf1_ch_1_delay_reg <= "0000000000000000";
        rf1_ch_1_delay_wack <= '0';
      else
        if rf1_ch_1_delay_wreq = '1' then
          rf1_ch_1_delay_reg <= wr_dat_d0;
        end if;
        rf1_ch_1_delay_wack <= rf1_ch_1_delay_wreq;
      end if;
    end if;
  end process;
  rf1_ch_1_delay_wr_o <= rf1_ch_1_delay_wack;

  -- Register rf2_common
  rf2_common_mixer_en_o <= rf2_common_mixer_en_reg;
  rf2_common_mux_sel_o <= rf2_common_mux_sel_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf2_common_mixer_en_reg <= '0';
        rf2_common_mux_sel_reg <= "00";
        rf2_common_wack <= '0';
      else
        if rf2_common_wreq = '1' then
          rf2_common_mixer_en_reg <= wr_dat_d0(0);
          rf2_common_mux_sel_reg <= wr_dat_d0(2 downto 1);
        end if;
        rf2_common_wack <= rf2_common_wreq;
      end if;
    end if;
  end process;

  -- Register rf2_ch_0_csr
  rf2_ch_0_csr_delay_oen_o <= rf2_ch_0_csr_delay_oen_reg;
  rf2_ch_0_csr_mux_sel_o <= rf2_ch_0_csr_mux_sel_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf2_ch_0_csr_delay_oen_reg <= '0';
        rf2_ch_0_csr_mux_sel_reg <= '0';
        rf2_ch_0_csr_wack <= '0';
      else
        if rf2_ch_0_csr_wreq = '1' then
          rf2_ch_0_csr_delay_oen_reg <= wr_dat_d0(0);
          rf2_ch_0_csr_mux_sel_reg <= wr_dat_d0(1);
        end if;
        rf2_ch_0_csr_wack <= rf2_ch_0_csr_wreq;
      end if;
    end if;
  end process;

  -- Register rf2_ch_0_delay
  rf2_ch_0_delay_o <= rf2_ch_0_delay_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf2_ch_0_delay_reg <= "0000000000000000";
        rf2_ch_0_delay_wack <= '0';
      else
        if rf2_ch_0_delay_wreq = '1' then
          rf2_ch_0_delay_reg <= wr_dat_d0;
        end if;
        rf2_ch_0_delay_wack <= rf2_ch_0_delay_wreq;
      end if;
    end if;
  end process;
  rf2_ch_0_delay_wr_o <= rf2_ch_0_delay_wack;

  -- Register rf2_ch_1_csr
  rf2_ch_1_csr_delay_oen_o <= rf2_ch_1_csr_delay_oen_reg;
  rf2_ch_1_csr_mux_sel_o <= rf2_ch_1_csr_mux_sel_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf2_ch_1_csr_delay_oen_reg <= '0';
        rf2_ch_1_csr_mux_sel_reg <= '0';
        rf2_ch_1_csr_wack <= '0';
      else
        if rf2_ch_1_csr_wreq = '1' then
          rf2_ch_1_csr_delay_oen_reg <= wr_dat_d0(0);
          rf2_ch_1_csr_mux_sel_reg <= wr_dat_d0(1);
        end if;
        rf2_ch_1_csr_wack <= rf2_ch_1_csr_wreq;
      end if;
    end if;
  end process;

  -- Register rf2_ch_1_delay
  rf2_ch_1_delay_o <= rf2_ch_1_delay_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rf2_ch_1_delay_reg <= "0000000000000000";
        rf2_ch_1_delay_wack <= '0';
      else
        if rf2_ch_1_delay_wreq = '1' then
          rf2_ch_1_delay_reg <= wr_dat_d0;
        end if;
        rf2_ch_1_delay_wack <= rf2_ch_1_delay_wreq;
      end if;
    end if;
  end process;
  rf2_ch_1_delay_wr_o <= rf2_ch_1_delay_wack;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, rf1_common_wack, rf1_ch_0_csr_wack, rf1_ch_0_delay_wack, rf1_ch_1_csr_wack, rf1_ch_1_delay_wack, rf2_common_wack, rf2_ch_0_csr_wack, rf2_ch_0_delay_wack, rf2_ch_1_csr_wack, rf2_ch_1_delay_wack) begin
    rf1_common_wreq <= '0';
    rf1_ch_0_csr_wreq <= '0';
    rf1_ch_0_delay_wreq <= '0';
    rf1_ch_1_csr_wreq <= '0';
    rf1_ch_1_delay_wreq <= '0';
    rf2_common_wreq <= '0';
    rf2_ch_0_csr_wreq <= '0';
    rf2_ch_0_delay_wreq <= '0';
    rf2_ch_1_csr_wreq <= '0';
    rf2_ch_1_delay_wreq <= '0';
    case wr_adr_d0(4 downto 1) is
    when "0000" =>
      -- Reg rf1_common
      rf1_common_wreq <= wr_req_d0;
      wr_ack_int <= rf1_common_wack;
    when "0100" =>
      -- Reg rf1_ch_0_csr
      rf1_ch_0_csr_wreq <= wr_req_d0;
      wr_ack_int <= rf1_ch_0_csr_wack;
    when "0101" =>
      -- Reg rf1_ch_0_delay
      rf1_ch_0_delay_wreq <= wr_req_d0;
      wr_ack_int <= rf1_ch_0_delay_wack;
    when "0110" =>
      -- Reg rf1_ch_1_csr
      rf1_ch_1_csr_wreq <= wr_req_d0;
      wr_ack_int <= rf1_ch_1_csr_wack;
    when "0111" =>
      -- Reg rf1_ch_1_delay
      rf1_ch_1_delay_wreq <= wr_req_d0;
      wr_ack_int <= rf1_ch_1_delay_wack;
    when "1000" =>
      -- Reg rf2_common
      rf2_common_wreq <= wr_req_d0;
      wr_ack_int <= rf2_common_wack;
    when "1100" =>
      -- Reg rf2_ch_0_csr
      rf2_ch_0_csr_wreq <= wr_req_d0;
      wr_ack_int <= rf2_ch_0_csr_wack;
    when "1101" =>
      -- Reg rf2_ch_0_delay
      rf2_ch_0_delay_wreq <= wr_req_d0;
      wr_ack_int <= rf2_ch_0_delay_wack;
    when "1110" =>
      -- Reg rf2_ch_1_csr
      rf2_ch_1_csr_wreq <= wr_req_d0;
      wr_ack_int <= rf2_ch_1_csr_wack;
    when "1111" =>
      -- Reg rf2_ch_1_delay
      rf2_ch_1_delay_wreq <= wr_req_d0;
      wr_ack_int <= rf2_ch_1_delay_wack;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, rf1_common_mixer_en_reg, rf1_common_mux_sel_reg, rf1_ch_0_csr_delay_oen_reg, rf1_ch_0_csr_mux_sel_reg, rf1_ch_1_csr_delay_oen_reg, rf1_ch_1_csr_mux_sel_reg, rf2_common_mixer_en_reg, rf2_common_mux_sel_reg, rf2_ch_0_csr_delay_oen_reg, rf2_ch_0_csr_mux_sel_reg, rf2_ch_1_csr_delay_oen_reg, rf2_ch_1_csr_mux_sel_reg) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    case adr_int(4 downto 1) is
    when "0000" =>
      -- Reg rf1_common
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= rf1_common_mixer_en_reg;
      rd_dat_d0(2 downto 1) <= rf1_common_mux_sel_reg;
      rd_dat_d0(15 downto 3) <= (others => '0');
    when "0100" =>
      -- Reg rf1_ch_0_csr
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= rf1_ch_0_csr_delay_oen_reg;
      rd_dat_d0(1) <= rf1_ch_0_csr_mux_sel_reg;
      rd_dat_d0(15 downto 2) <= (others => '0');
    when "0101" =>
      -- Reg rf1_ch_0_delay
      rd_ack_d0 <= rd_req_int;
    when "0110" =>
      -- Reg rf1_ch_1_csr
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= rf1_ch_1_csr_delay_oen_reg;
      rd_dat_d0(1) <= rf1_ch_1_csr_mux_sel_reg;
      rd_dat_d0(15 downto 2) <= (others => '0');
    when "0111" =>
      -- Reg rf1_ch_1_delay
      rd_ack_d0 <= rd_req_int;
    when "1000" =>
      -- Reg rf2_common
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= rf2_common_mixer_en_reg;
      rd_dat_d0(2 downto 1) <= rf2_common_mux_sel_reg;
      rd_dat_d0(15 downto 3) <= (others => '0');
    when "1100" =>
      -- Reg rf2_ch_0_csr
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= rf2_ch_0_csr_delay_oen_reg;
      rd_dat_d0(1) <= rf2_ch_0_csr_mux_sel_reg;
      rd_dat_d0(15 downto 2) <= (others => '0');
    when "1101" =>
      -- Reg rf2_ch_0_delay
      rd_ack_d0 <= rd_req_int;
    when "1110" =>
      -- Reg rf2_ch_1_csr
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= rf2_ch_1_csr_delay_oen_reg;
      rd_dat_d0(1) <= rf2_ch_1_csr_mux_sel_reg;
      rd_dat_d0(15 downto 2) <= (others => '0');
    when "1111" =>
      -- Reg rf2_ch_1_delay
      rd_ack_d0 <= rd_req_int;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
