# Every register in a synchroniser chain should be marked as a ASYNC_REG in the RTL.
# Unfortunately not all are, and changing the RTL involves people, so we do it here 
# in the constraints.

set     need_async_reg [get_cells -hier -filter {name=~*_reg                               && file_name=~*dmtd_sampler.vhd}]
lappend need_async_reg [get_cells -hier -filter {name=~*mdio_wr_spec_rx_cal_stat_sync*_reg && file_name=~*ep_pcs_tbi_mdio_wb.vhd}]

set_property ASYNC_REG true [get_cells $need_async_reg]


