#ifndef __CHEBY__WR2RF_CTRL_REGS__H__
#define __CHEBY__WR2RF_CTRL_REGS__H__

#include "wr2rf_rftrigger_regs.h"
#define WR2RF_CTRL_REGS_SIZE 12288 /* 0x3000 = 12KB */

/* Registers for rf1 vtus */
#define WR2RF_CTRL_REGS_RF1_VTUS 0x0UL
#define WR2RF_CTRL_REGS_RF1_VTUS_SIZE 512 /* 0x200 */

/* Registers for rf2 vtus */
#define WR2RF_CTRL_REGS_RF2_VTUS 0x200UL
#define WR2RF_CTRL_REGS_RF2_VTUS_SIZE 512 /* 0x200 */

/* Registers for rf1 rfnco */
#define WR2RF_CTRL_REGS_RF1_RFNCO 0x1000UL
#define WR2RF_CTRL_REGS_RF1_RFNCO_SIZE 4096 /* 0x1000 = 4KB */

/* Registers for rf2 rfnco */
#define WR2RF_CTRL_REGS_RF2_RFNCO 0x2000UL
#define WR2RF_CTRL_REGS_RF2_RFNCO_SIZE 4096 /* 0x1000 = 4KB */

struct wr2rf_ctrl_regs {
  /* [0x0]: SUBMAP Registers for rf1 vtus */
  struct wr2rf_rftrigger_regs rf1_vtus;

  /* padding to: 128 words */
  uint32_t __padding_0[60];

  /* [0x200]: SUBMAP Registers for rf2 vtus */
  struct wr2rf_rftrigger_regs rf2_vtus;

  /* padding to: 1024 words */
  uint32_t __padding_1[828];

  /* [0x1000]: SUBMAP Registers for rf1 rfnco */
  uint32_t rf1_rfnco[1024];

  /* [0x2000]: SUBMAP Registers for rf2 rfnco */
  uint32_t rf2_rfnco[1024];
};

#endif /* __CHEBY__WR2RF_CTRL_REGS__H__ */
