#ifndef __CHEBY__WR2RF_INIT_RF_CH_REGS__H__
#define __CHEBY__WR2RF_INIT_RF_CH_REGS__H__
#define WR2RF_INIT_RF_CH_REGS_SIZE 16 /* 0x10 */

/* Control register for both channels */
#define WR2RF_INIT_RF_CH_REGS_COMMON 0x0UL
#define WR2RF_INIT_RF_CH_REGS_COMMON_MIXER_EN 0x1UL
#define WR2RF_INIT_RF_CH_REGS_COMMON_MUX_SEL_MASK 0x6UL
#define WR2RF_INIT_RF_CH_REGS_COMMON_MUX_SEL_SHIFT 1

/* None */
#define WR2RF_INIT_RF_CH_REGS_CH 0x8UL
#define WR2RF_INIT_RF_CH_REGS_CH_SIZE 4 /* 0x4 */

/* None */
#define WR2RF_INIT_RF_CH_REGS_CH_CSR 0x0UL
#define WR2RF_INIT_RF_CH_REGS_CH_CSR_DELAY_OEN 0x1UL
#define WR2RF_INIT_RF_CH_REGS_CH_CSR_MUX_SEL 0x2UL

/* None */
#define WR2RF_INIT_RF_CH_REGS_CH_DELAY 0x2UL

struct wr2rf_init_rf_ch_regs {
  /* [0x0]: REG (rw) Control register for both channels */
  uint16_t common;

  /* padding to: 8 words */
  uint8_t __padding_0[6];

  /* [0x8]: REPEAT (no description) */
  struct ch {
    /* [0x0]: REG (rw) (no description) */
    uint16_t csr;

    /* [0x2]: REG (wo) (no description) */
    uint16_t delay;
  } ch[2];
};

#endif /* __CHEBY__WR2RF_INIT_RF_CH_REGS__H__ */
