#ifndef __REGS_H_
#define __REGS_H_

#include "wr2rf_vme_regs.h"

/* Main PLL.  */
#define PLL_BASE (WR2RF_VME_REGS_INIT + WR2RF_INIT_REGS_PLL_SPI)
#define PLL_CS   0

/* DDS  */
#define DDS_BASE (WR2RF_VME_REGS_INIT + WR2RF_INIT_REGS_RF_SPI)
#define DDS_CS   0

/* DACs  */
#define DAC_BASE DDS_BASE
#define DAC1_CS  1
#define DAC2_CS  2

/* DAC regs.  */
#define DAC_REG_SPI_CONTROL  0
#define DAC_REG_DATA_CONTROL 2
#define DAC_REG_POWER_DOWN   3
#define DAC_REG_SETUP_HOLD   4
#define DAC_REG_TIMING_ADJ   5
#define DAC_REG_SEEK         6
#define DAC_REG_MIX_MODE     0x0a
#define DAC_REG_DAC1_FSC_HI  0x0b
#define DAC_REG_DAC1_FSC_LO  0x0c
#define DAC_REG_AUXDAC1_HI   0x0d
#define DAC_REG_AUXDAC1_LO   0x0e
#define DAC_REG_DAC2_FSC_HI  0x0f
#define DAC_REG_DAC2_FSC_LO  0x10
#define DAC_REG_AUXDAC2_HI   0x11
#define DAC_REG_AUXDAC2_LO   0x12
#define DAC_REG_VERSION      0x1f


#endif /* __REGS_H_ */
